/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.tables.records.VCoreFormRecord;

import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VCoreForm extends TableImpl<VCoreFormRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.v_core_form</code>
     */
    public static final VCoreForm V_CORE_FORM = new VCoreForm();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VCoreFormRecord> getRecordType() {
        return VCoreFormRecord.class;
    }

    /**
     * The column <code>common_dd.v_core_form.key_element</code>.
     */
    public final TableField<VCoreFormRecord, Integer> KEY_ELEMENT = createField(DSL.name("key_element"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_core_form.key_parent_element</code>.
     */
    public final TableField<VCoreFormRecord, Integer> KEY_PARENT_ELEMENT = createField(DSL.name("key_parent_element"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_core_form.key_element_type</code>.
     */
    public final TableField<VCoreFormRecord, Integer> KEY_ELEMENT_TYPE = createField(DSL.name("key_element_type"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_core_form.dn</code>.
     */
    public final TableField<VCoreFormRecord, String> DN = createField(DSL.name("dn"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_core_form.order_nr</code>.
     */
    public final TableField<VCoreFormRecord, Integer> ORDER_NR = createField(DSL.name("order_nr"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_core_form.short_name</code>.
     */
    public final TableField<VCoreFormRecord, String> SHORT_NAME = createField(DSL.name("short_name"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_core_form.is_public</code>.
     */
    public final TableField<VCoreFormRecord, Integer> IS_PUBLIC = createField(DSL.name("is_public"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_core_form.hier_lang</code>.
     */
    public final TableField<VCoreFormRecord, String> HIER_LANG = createField(DSL.name("hier_lang"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_core_form.stage</code>.
     */
    public final TableField<VCoreFormRecord, Integer> STAGE = createField(DSL.name("stage"), SQLDataType.INTEGER, this, "");

    private VCoreForm(Name alias, Table<VCoreFormRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VCoreForm(Name alias, Table<VCoreFormRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        create view "v_core_form" as  SELECT key_element,
          key_parent_element,
          key_element_type,
          dn,
          order_nr,
          short_name,
          is_public,
          hier_lang,
          stage
         FROM common_dd.t_core_element_hierarchy
        WHERE (key_element IN ( SELECT t_core_element_hierarchy_1.key_parent_element
                 FROM (common_dd.t_core_element_hierarchy t_core_element_hierarchy_1
                   RIGHT JOIN common_dd.t_core_variable ON ((t_core_variable.key_variable = t_core_element_hierarchy_1.key_element)))));
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_core_form</code> table reference
     */
    public VCoreForm(String alias) {
        this(DSL.name(alias), V_CORE_FORM);
    }

    /**
     * Create an aliased <code>common_dd.v_core_form</code> table reference
     */
    public VCoreForm(Name alias) {
        this(alias, V_CORE_FORM);
    }

    /**
     * Create a <code>common_dd.v_core_form</code> table reference
     */
    public VCoreForm() {
        this(DSL.name("v_core_form"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VCoreForm as(String alias) {
        return new VCoreForm(DSL.name(alias), this);
    }

    @Override
    public VCoreForm as(Name alias) {
        return new VCoreForm(alias, this);
    }

    @Override
    public VCoreForm as(Table<?> alias) {
        return new VCoreForm(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreForm rename(String name) {
        return new VCoreForm(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreForm rename(Name name) {
        return new VCoreForm(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreForm rename(Table<?> name) {
        return new VCoreForm(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreForm where(Condition condition) {
        return new VCoreForm(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreForm where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreForm where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreForm where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreForm where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreForm where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreForm where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreForm where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreForm whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreForm whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
